package com.zhili.zkstationserver.configuration;

import com.zhili.zkstationserver.util.IPUtil;
import lombok.Data;
import lombok.extern.slf4j.Slf4j;
import org.apache.commons.lang3.StringUtils;
import org.springframework.beans.factory.annotation.Value;
import org.springframework.context.annotation.Configuration;

import javax.annotation.PostConstruct;
import java.net.UnknownHostException;

/**
 * @author ：HuangBin
 * @description：TODO
 * @date ：2022/12/20 17:44
 */
@Configuration
@Data
@Slf4j
public class ServerConfig {
    String zkRoot;

    String serviceName;

    String serviceCenterName;

    @Value("${station-server.port}")
    //服务器启动端口
    Integer port;

    @Value("${server.port}")
    Integer httpPort;

    @Value("${station-server.advertised-network:}")
    String advertisedNetwork;

    //实例id
    String instanceId;

    String ipAddress;

    String topics[];

    @PostConstruct
    public void init() throws UnknownHostException {
        serviceName = "StationServer";
        serviceCenterName = "ServiceCenter";
        zkRoot = "/servers";
        ipAddress = null;
        System.out.println("advertisedNetwork("+ advertisedNetwork.length()+"):" + advertisedNetwork);
        if (StringUtils.isNotBlank(advertisedNetwork)) {
            ipAddress = IPUtil.getIpAddress(advertisedNetwork);
        } else {
            ipAddress = IPUtil.getIpAddress();
        }
    }
}
