package com.zhili.zkstationserver.controller.advice;

import com.alibaba.fastjson.JSON;
import lombok.extern.slf4j.Slf4j;
import org.springframework.core.MethodParameter;
import org.springframework.http.MediaType;
import org.springframework.http.server.ServerHttpRequest;
import org.springframework.http.server.ServerHttpResponse;
import org.springframework.web.bind.annotation.ExceptionHandler;
import org.springframework.web.bind.annotation.RestControllerAdvice;
import org.springframework.web.servlet.mvc.method.annotation.ResponseBodyAdvice;

/**
 * @author ：HuangBin
 * @description：TODO
 * @date ：2022/9/28 11:04
 */
@RestControllerAdvice(basePackages = "com.zhili.zkstationserver.controller")
@Slf4j
public class ErrorMessageAdvice implements ResponseBodyAdvice {


    @ExceptionHandler(value=RuntimeException.class)
    public GlobalError runtimeExceptionHandler(Exception ex){
        ex.printStackTrace();
        return GlobalError.newGlobalError(GlobalError.ErrorType.INNER_ERROR);
    }

    @ExceptionHandler(value=GlobalError.class)
    public GlobalError globalExceptionHandler(Exception ex){
        ex.printStackTrace();
        return (GlobalError) ex;
    }

    @Override
    public boolean supports(MethodParameter methodParameter, Class aClass) {
        return true;
    }

    @Override
    public Object beforeBodyWrite(Object o, MethodParameter methodParameter, MediaType mediaType, Class aClass, ServerHttpRequest serverHttpRequest, ServerHttpResponse serverHttpResponse) {
        if(o instanceof GlobalError){
            return CommonResponse.newFail((GlobalError) o);
        }
        if(o instanceof String){
            serverHttpResponse.getHeaders().setContentType(MediaType.APPLICATION_JSON);
            return JSON.toJSONString(CommonResponse.newSuccess(o));
        }
        return CommonResponse.newSuccess(o);
    }
}
