package com.zhili.zkstationserver.controller.advice;

import lombok.Getter;
import org.apache.commons.lang3.StringUtils;

/**
 * @author ：HuangBin
 * @description：TODO
 * @date ：2022/9/28 13:00
 */
public class GlobalError extends RuntimeException{
    public enum ErrorType {
        SUCCESS(0,"success"),
        INNER_ERROR(1, "服务器内部异常"),
        ERROR(2, "操作失败"),
        TOKEN_ERROR(3,"token错误")
        ;
        @Getter
        private final Integer errCode;
        @Getter
        private final String errMsg;

        ErrorType(Integer errCode, String errMsg){
            this.errCode = errCode;
            this.errMsg = errMsg;
        }
    }
    ErrorType errorType;

    String errMsg;

    GlobalError(ErrorType type){
        this.errorType = type;
    }

    void setErrMsg(String errMsg){
        this.errMsg = errMsg;
    }

    public static GlobalError newGlobalError(ErrorType errorType){
        return new GlobalError(errorType);
    }

    public static GlobalError newGlobalError(ErrorType errorType, String errMsg){
        GlobalError globalError = new GlobalError(errorType);
        globalError.setErrMsg(errMsg);
        return globalError;
    }

    public Integer getErrCode(){
        return this.errorType.getErrCode();
    }

    public String getErrMsg(){
        if(StringUtils.isBlank(errMsg)){
            return this.errorType.getErrMsg();
        }else{
            return errMsg;
        }

    }
}
