package com.zhili.zkstationserver.handler;


import com.zhili.zkstationserver.dto.StationMessage;
import com.zhili.zkstationserver.util.BytesUtil;
import io.netty.buffer.ByteBuf;
import io.netty.channel.ChannelHandlerContext;
import io.netty.handler.codec.MessageToByteEncoder;

/**
 * @author ：HuangBin
 * @description：TODO
 * @date ：2022/12/20 15:40
 */
public class StationMessageEncoder extends MessageToByteEncoder<StationMessage> {
    public static final byte[] START = {(byte) 0xaa, (byte) 0xf5};
    public static final int baseLen = 9;

    @Override
    protected void encode(ChannelHandlerContext ctx, StationMessage stationMessage, ByteBuf byteBuf) throws Exception {
        //全部长度
        int len = baseLen + stationMessage.getData().length;
        //所有数据
        byte[] messageBytes = new byte[len];
        //长度字节
        byte[] lenBytes = BytesUtil.fromIntWithLowerFirst(len, 2);
        int cmd = stationMessage.getCommand();
        //命令字节
        byte[] cmdBytes = BytesUtil.fromIntWithLowerFirst(cmd, 2);

        //校验和数据(命令+数据)
        byte[] checkSumObj = new byte[2 + stationMessage.getData().length];
        BytesUtil.setSubBytes(checkSumObj, 0, cmdBytes);
        BytesUtil.setSubBytes(checkSumObj, 2, stationMessage.getData());
        byte checkSumByte = BytesUtil.sumCheck(checkSumObj);

        //构建所有数据
        BytesUtil.setSubBytes(messageBytes, 0, START);
        BytesUtil.setSubBytes(messageBytes, 2, lenBytes);
        messageBytes[4] = (byte) 0;
        messageBytes[5] = (byte) 0;
        BytesUtil.setSubBytes(messageBytes, 6, cmdBytes);
        BytesUtil.setSubBytes(messageBytes, 8, stationMessage.getData());
        messageBytes[len - 1] = checkSumByte;

        //统一写出
        byteBuf.writeBytes(messageBytes);
    }
}
