package com.zhili.zkstationserver.util;


import java.net.*;
import java.util.Enumeration;

/**
 * @author ：HuangBin
 * @description：TODO
 * @date ：2023/1/24 2:08
 */
public class IPUtil {
    public static String getIpAddress() throws UnknownHostException {
        return InetAddress.getLocalHost().getHostAddress();
    }


    public static String getIpAddress(String network) throws UnknownHostException {
        String sub = network.substring(0, network.lastIndexOf(".") - 1);
        Enumeration<NetworkInterface> allNetInterfaces = null;
        try {
            allNetInterfaces = NetworkInterface.getNetworkInterfaces();
        } catch (SocketException e) {
            e.printStackTrace();
            return getIpAddress();
        }
        while (allNetInterfaces.hasMoreElements()) {
            NetworkInterface netInterface = (NetworkInterface) allNetInterfaces.nextElement();
            Enumeration<InetAddress> addresses = netInterface.getInetAddresses();
            while (addresses.hasMoreElements()) {
                InetAddress inetAddress = (InetAddress) addresses.nextElement();
                if (inetAddress instanceof Inet4Address
                        && !inetAddress.isLoopbackAddress() //loopback地址即本机地址，IPv4的loopback范围是127.0.0.0 ~ 127.255.255.255
                        && !inetAddress.getHostAddress().contains(":")) {
                    String ip = inetAddress.getHostAddress();
                    if (ip.contains(sub)) {
                        return ip;
                    }
                }
            }
        }
        return getIpAddress();
    }

    public static void main(String[] args) throws UnknownHostException {
        String ipAddress = getIpAddress("192.168.10.*");
        System.out.println(ipAddress);
    }
}
