package com.zhili.zkstationserver.util;

import com.zhili.zkstationserver.dto.StationMessage;
import io.netty.channel.Channel;
import io.netty.channel.group.ChannelGroup;
import io.netty.channel.group.ChannelMatcher;
import io.netty.channel.group.DefaultChannelGroup;
import io.netty.util.AttributeKey;
import io.netty.util.concurrent.GlobalEventExecutor;
import org.apache.commons.lang3.StringUtils;

import java.util.HashSet;
import java.util.Set;

/**
 * @author ：HuangBin
 * @description：TODO
 * @date ：2022/12/20 16:54
 */

public class StationCenter {
    static final ChannelGroup channelGroup = new DefaultChannelGroup(GlobalEventExecutor.INSTANCE);

    public static void add(Channel ch) {
        channelGroup.add(ch);
    }

    public static void markStation(Channel ch, Object stationCode) {
        Channel channel = channelGroup.find(ch.id());
        channel.attr(AttributeKey.valueOf("station")).set(stationCode);
    }

    public static void sendToChannel(String channelIdStr, StationMessage msg) {
        channelGroup.writeAndFlush(msg, new ChannelMatcher() {
            @Override
            public boolean matches(Channel channel) {
                String s = channel.id().asLongText();
                return s.equals(channelIdStr);
            }
        });
    }

    public static String getChannelIdStr(Channel ch){
        return ch.id().asLongText();
    }

    public static Boolean stationExist(String stationCode) {
        for (Channel ch : channelGroup) {
            Object stationCodeObj = ch.attr(AttributeKey.valueOf("station")).get();
            if (stationCodeObj == null) {
                continue;
            }
            String code = stationCodeObj.toString();
            if (StringUtils.isBlank(code)) {
                continue;
            }
            if (code.equals(stationCode)) {
                return true;
            }
        }
        return false;
    }
}
